Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math3.distribution
Class LogNormalDistribution

    java.lang.Object
      org.apache.commons.math3.distribution.AbstractRealDistribution
          org.apache.commons.math3.distribution.LogNormalDistribution

All Implemented Interfaces:
  Serializable, RealDistribution

    public class LogNormalDistribution

extends AbstractRealDistribution

Implementation of the log-normal (gaussian) distribution.

Parameters: `X` is log-normally distributed if its natural logarithm `log(X)` is normally distributed. The probability distribution function of `X` is given by (for `x > 0`)

`exp(-0.5 * ((ln(x) - m) / s)^2) / (s * sqrt(2 * pi) * x)`

- `m` is the scale parameter: this is the mean of the normally distributed natural logarithm of this distribution,
- `s` is the shape parameter: this is the standard deviation of the normally distributed natural logarithm of this distribution.

Since:
  3.0
Version:
  $Id: LogNormalDistribution.java 1422195 2012-12-15 06:45:18Z psteitz $
See Also:
  Log-normal distribution (Wikipedia), Log Normal distribution (MathWorld), Serialized Form

Field Summary
`static double` | `DEFAULT_INVERSE_ABSOLUTE_ACCURACY` Default inverse cumulative probability accuracy.

Fields inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution
`random, randomData, SOLVER_DEFAULT_ABSOLUTE_ACCURACY`

Constructor Summary
`LogNormalDistribution()` Create a log-normal distribution, where the mean and standard deviation of the `normally distributed` natural logarithm of the log-normal distribution are equal to zero and one respectively.
`LogNormalDistribution(double scale, double shape)` Create a log-normal distribution using the specified scale and shape.
`LogNormalDistribution(double scale, double shape, double inverseCumAccuracy)` Create a log-normal distribution using the specified scale, shape and inverse cumulative distribution accuracy.
`LogNormalDistribution(RandomGenerator rng, double scale, double shape, double inverseCumAccuracy)` Creates a log-normal distribution.

Method Summary
`double` | `cumulativeProbability(double x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
`double` | `cumulativeProbability(double x0, double x1)` Deprecated. See `RealDistribution.cumulativeProbability(double,double)`
`double` | `density(double x)` Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`.
`double` | `getNumericalMean()` Use this method to get the numerical value of the mean of this distribution.
`double` | `getNumericalVariance()` Use this method to get the numerical value of the variance of this distribution.
`double` | `getScale()` Returns the scale parameter of this distribution.
`double` | `getShape()` Returns the shape parameter of this distribution.
`protected double` | `getSolverAbsoluteAccuracy()` Returns the solver absolute accuracy for inverse cumulative computation.
`double` | `getSupportLowerBound()` Access the lower bound of the support.
`double` | `getSupportUpperBound()` Access the upper bound of the support.
`boolean` | `isSupportConnected()` Use this method to get information about whether the support is connected, i.e.
`boolean` | `isSupportLowerBoundInclusive()` Whether or not the lower bound of support is in the domain of the density function.
`boolean` | `isSupportUpperBoundInclusive()` Whether or not the upper bound of support is in the domain of the density function.
`double` | `probability(double x0, double x1)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(x0 < X <= x1)`.
`double` | `sample()` Generate a random value sampled from this distribution.

Methods inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution
`inverseCumulativeProbability, probability, reseedRandomGenerator, sample`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEFAULT_INVERSE_ABSOLUTE_ACCURACY

    public static final double DEFAULT_INVERSE_ABSOLUTE_ACCURACY

  Default inverse cumulative probability accuracy.

  See Also:
    Constant Field Values

Constructor Detail

### LogNormalDistribution

    public LogNormalDistribution()

  Create a log-normal distribution, where the mean and standard deviation of the `normally distributed` natural logarithm of the log-normal distribution are equal to zero and one respectively. In other words, the scale of the returned distribution is `0`, while its shape is `1`.

### LogNormalDistribution

    public LogNormalDistribution(double scale,
                                 double shape)
                          throws NotStrictlyPositiveException

  Create a log-normal distribution using the specified scale and shape.

  Parameters:
    `scale` - the scale parameter of this distribution
    `shape` - the shape parameter of this distribution
  Throws:
    `NotStrictlyPositiveException` - if `shape <= 0`.

### LogNormalDistribution

    public LogNormalDistribution(double scale,
                                 double shape,
                                 double inverseCumAccuracy)
                          throws NotStrictlyPositiveException

  Create a log-normal distribution using the specified scale, shape and inverse cumulative distribution accuracy.

  Parameters:
    `scale` - the scale parameter of this distribution
    `shape` - the shape parameter of this distribution
    `inverseCumAccuracy` - Inverse cumulative probability accuracy.
  Throws:
    `NotStrictlyPositiveException` - if `shape <= 0`.

### LogNormalDistribution

    public LogNormalDistribution(RandomGenerator rng,
                                 double scale,
                                 double shape,
                                 double inverseCumAccuracy)
                          throws NotStrictlyPositiveException

  Creates a log-normal distribution.

  Parameters:
    `rng` - Random number generator.
    `scale` - Scale parameter of this distribution.
    `shape` - Shape parameter of this distribution.
    `inverseCumAccuracy` - Inverse cumulative probability accuracy.
  Throws:
    `NotStrictlyPositiveException` - if `shape <= 0`.
  Since:
    3.1

Method Detail

### getScale

    public double getScale()

  Returns the scale parameter of this distribution.

  Returns:
    the scale parameter

### getShape

    public double getShape()

  Returns the shape parameter of this distribution.

  Returns:
    the shape parameter

### density

    public double density(double x)

  Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient. For scale `m`, and shape `s` of this distribution, the PDF is given by
  - `0` if `x <= 0`,
  - `exp(-0.5 * ((ln(x) - m) / s)^2) / (s * sqrt(2 * pi) * x)` otherwise.

  Parameters:
    `x` - the point at which the PDF is evaluated
  Returns:
    the value of the probability density function at point `x`

### cumulativeProbability

    public double cumulativeProbability(double x)

  For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution. For scale `m`, and shape `s` of this distribution, the CDF is given by
  - `0` if `x <= 0`,
  - `0` if `ln(x) - m < 0` and `m - ln(x) > 40 * s`, as in these cases the actual value is within `Double.MIN_VALUE` of 0,
  - `1` if `ln(x) - m >= 0` and `ln(x) - m > 40 * s`, as in these cases the actual value is within `Double.MIN_VALUE` of 1,
  - `0.5 + 0.5 * erf((ln(x) - m) / (s * sqrt(2))` otherwise.

  Parameters:
    `x` - the point at which the CDF is evaluated
  Returns:
    the probability that a random variable with this distribution takes a value less than or equal to `x`

### cumulativeProbability

    @Deprecated
    public double cumulativeProbability(double x0,
                                                   double x1)
                                 throws NumberIsTooLargeException

  Deprecated. See `RealDistribution.cumulativeProbability(double,double)`

  For a random variable `X` whose values are distributed according to this distribution, this method returns `P(x0 < X <= x1)`. The default implementation uses the identity

  `P(x0 < X <= x1) = P(X <= x1) - P(X <= x0)`

  Specified by:
    `cumulativeProbability` in interface `RealDistribution`
  Overrides:
    `cumulativeProbability` in class `AbstractRealDistribution`
  Parameters:
    `x0` - the exclusive lower bound
    `x1` - the inclusive upper bound
  Returns:
    the probability that a random variable with this distribution takes a value between `x0` and `x1`, excluding the lower and including the upper endpoint
  Throws:
    `NumberIsTooLargeException` - if `x0 > x1`

### probability

    public double probability(double x0,
                              double x1)
                       throws NumberIsTooLargeException

  For a random variable `X` whose values are distributed according to this distribution, this method returns `P(x0 < X <= x1)`.

  Overrides:
    `probability` in class `AbstractRealDistribution`
  Parameters:
    `x0` - Lower bound (excluded).
    `x1` - Upper bound (included).
  Returns:
    the probability that a random variable with this distribution takes a value between `x0` and `x1`, excluding the lower and including the upper endpoint.
  Throws:
    `NumberIsTooLargeException` - if `x0 > x1`. The default implementation uses the identity `P(x0 < X <= x1) = P(X <= x1) - P(X <= x0)`

### getSolverAbsoluteAccuracy

    protected double getSolverAbsoluteAccuracy()

  Returns the solver absolute accuracy for inverse cumulative computation. You can override this method in order to use a Brent solver with an absolute accuracy different from the default.

  Overrides:
    `getSolverAbsoluteAccuracy` in class `AbstractRealDistribution`
  Returns:
    the maximum absolute error in inverse cumulative probability estimates

### getNumericalMean

    public double getNumericalMean()

  Use this method to get the numerical value of the mean of this distribution. For scale `m` and shape `s`, the mean is `exp(m + s^2 / 2)`.

  Returns:
    the mean or `Double.NaN` if it is not defined

### getNumericalVariance

    public double getNumericalVariance()

  Use this method to get the numerical value of the variance of this distribution. For scale `m` and shape `s`, the variance is `(exp(s^2) - 1) * exp(2 * m + s^2)`.

  Returns:
    the variance (possibly `Double.POSITIVE_INFINITY` as for certain cases in `TDistribution`) or `Double.NaN` if it is not defined

### getSupportLowerBound

    public double getSupportLowerBound()

  Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

  `inf {x in R | P(X <= x) > 0}`.

  The lower bound of the support is always 0 no matter the parameters.

  Returns:
    lower bound of the support (always 0)

### getSupportUpperBound

    public double getSupportUpperBound()

  Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

  `inf {x in R | P(X <= x) = 1}`.

  The upper bound of the support is always positive infinity no matter the parameters.

  Returns:
    upper bound of the support (always `Double.POSITIVE_INFINITY`)

### isSupportLowerBoundInclusive

    public boolean isSupportLowerBoundInclusive()

  Whether or not the lower bound of support is in the domain of the density function. Returns true iff `getSupporLowerBound()` is finite and `density(getSupportLowerBound())` returns a non-NaN, non-infinite value.

  Returns:
    true if the lower bound of support is finite and the density function returns a non-NaN, non-infinite value there

### isSupportUpperBoundInclusive

    public boolean isSupportUpperBoundInclusive()

  Whether or not the upper bound of support is in the domain of the density function. Returns true iff `getSupportUpperBound()` is finite and `density(getSupportUpperBound())` returns a non-NaN, non-infinite value.

  Returns:
    true if the upper bound of support is finite and the density function returns a non-NaN, non-infinite value there

### isSupportConnected

    public boolean isSupportConnected()

  Use this method to get information about whether the support is connected, i.e. whether all values between the lower and upper bound of the support are included in the support. The support of this distribution is connected.

  Returns:
    `true`

### sample

    public double sample()

  Generate a random value sampled from this distribution. The default implementation uses the inversion method.

  Specified by:
    `sample` in interface `RealDistribution`
  Overrides:
    `sample` in class `AbstractRealDistribution`
  Returns:
    a random value.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2013 The Apache Software Foundation. All Rights Reserved.